/* -*- c -*- */
/* Copyright  2005 tedemo <tedemo@free.fr> */

var base = null;

var req = null;
var req_url = null;
var req_target_id = null;

var last_thread = null;
var last_thread_html = null;
var last_message = null;

var progress_url = null;
var progress_id  = null;
var progress_refresh = null;
var progress_update_interval = 300;

function get_base_url() {
  return document.location.href.replace (/\?.*/, '');
}

function offsetTop(e) {
  var o = 0;

  while (e) {
    o += e.offsetTop;
    e = e.offsetParent;
  }

  return o;
}

function show(e, scrollto) {
  if (e) {
    if (e.tagName.match (/^(table|div|p|h[0-9]|ul|ol|pre)$/i)) {
      e.style.display = 'block';
    } else if (e.tagName.match (/^li$/i)) {
      e.style.display = 'list-item';      
    } else {
      e.style.display = 'inline';
    }

    e.style.visibility = 'visible';

    if (scrollto) 
      window.scrollTo (0, offsetTop (e));
  }
  return false;
}

function hide(e) {
  if (e && e.style) {
    e.style.visibility = 'hidden';
    e.style.display = 'none';    
  }
  return false;
}

function toggle_visible(id, start_visible, scrollto) {

  if (id == null) {
    obj = document.getElementById ('z');
  } else {
    obj = document.getElementById (id);
  }

  if (obj == null) 
    return true;

  if (obj.style.visibility == '') {
    if (start_visible) 
      hide (obj);
    else
      show (obj, scrollto);
  } else if (obj.style.visibility == 'hidden') {
    show (obj, scrollto);
  } else {
    hide (obj);
  }

  return false;
}

function load_url(url, skip_if_busy, cb) {

  if (skip_if_busy && req != null) {
    return 0;
  }

  if (req != null) {
    req.onreadystatechange = noop;
    req.abort ();
    req = null;
  }

  req_url = url + '&nohf=' + Math.round (1+Math.random () * 10000);
  
  if (cb == null)
    cb = load_url_cb;

  if (window.XMLHttpRequest) {
    req = new XMLHttpRequest();
    if (req) {
      req.onreadystatechange = cb;
      req.open("GET", req_url, true);
      if (document.cookie)
	req.setRequestHeader ("Cookie", document.cookie);
      req.setRequestHeader ("Referer", document.location.href);
      req.send(null);
    }
  } else if (window.ActiveXObject) {
    req = new ActiveXObject("Microsoft.XMLHTTP");
    if (req) {
      req.onreadystatechange = cb;
      req.open("GET", req_url, true);
      if (document.cookie)
	req.setRequestHeader ("Cookie", document.cookie);
      req.setRequestHeader ("Referer", document.location.href);
      req.send();
    }
  }

  return req;
}

// replace a given objet by the content of the given url
function load_url_to_id(url, id, skip_if_busy) {
  if (load_url (url, skip_if_busy)) {
      req_target_id = id;
      return true;
  }

  return false;
}

function expand_thread(link, id) {
  var t;

  if (last_thread && last_thread_html) {
    t = document.getElementById (last_thread);
    if (t) {
      hide_last_message ();
      t.innerHTML = last_thread_html;
    }
  }

  last_thread = id;
  t = document.getElementById (id);
  if (t) {
    last_thread_html = t.innerHTML;
  }

  window.scrollTo (0, offsetTop (link));

  return load_url_to_id(link.href, id);
}

function msgnum_from_link(link) {
  var i;
  i = link.href.indexOf('msgnum=');
  if (i >= 0)
    return link.href.slice (i + 7);
  return 0;
}

function link_from_msgnum(msgnum) {
  var i;
  
  if (msgnum < 0) 
    msgnum = -msgnum;

  for (i = 0; i < document.links.length; i++) {
    if (document.links[i].href.match ('msgnum=' + msgnum))
      return i;
  }

  return 0;
}


function message_is_read(link) {
  var attr;

  attr = link.getAttribute ('class');
  if (attr) 
    return attr.match (/ read/);

  attr = link.getAttribute ('className');
  if (attr) 
    return attr.match (/ read/);

  return false;
}

function expand_message(link, id) {
  var attr, msgnum;

  if (last_message && last_message != id) {
    hide_last_message ();
  }

  last_message = id;

  window.scrollTo (0, offsetTop (link));

  if (!load_url_to_id (link.href, id))
    return false;

  show(document.getElementById (id));
  show_progress_bar (link.href, id);

  // mark article as read
  attr = link.getAttribute ('class');
  if (attr) {
    if (!attr.match (/ read/)) {
      link.setAttribute ('class', attr + ' read');
    }
  } else {
    // for ie 
    attr = link.getAttribute ('className');
    if (!attr.match (/ read/)) {
      link.setAttribute ('className', attr + ' read');
    }
  }

  return true;
}

function download_set(link) {
  window.open (link.href, "dlset", "menubar=n,toolbar=n,status=n");
  return false;
}

function hide_last_message() {
  var msg;

  if (last_message) {
    msg = document.getElementById(last_message);
    if (msg.innerHTML)
      msg.innerHTML = '';
    hide (msg);
    last_message = null;
  }
}


function form_url_encode(form) {
  var i, e, s, v;

  s = 'nohf=1';
  for (i = 0; i < form.length; i++) {
    e = form.elements[i];

    if (e.type.match (/^(checkbox|radio)/i) && !e.checked) 
      continue;

    v = encodeURI (e.value);
    v = v.replace (/\+/g, '%2B');
    v = v.replace (/&/g,  '%26');
    s = s + '&' + e.name + '=' + v;
  }

  return s;
}

function post_form(form) {		
  var data;

  if (req != null) {
    req.onreadystatechange = noop;
    req.abort ();
    req = null;
  }

  req_url = get_base_url();
  data = form_url_encode (form);

  if (window.XMLHttpRequest) {
    req = new XMLHttpRequest();
    req.onreadystatechange = load_url_cb;
    req.open("POST", req_url, true);	
    req.setRequestHeader ("Content-Type", "application/x-www-form-urlencoded"); 
    if (document.cookie)
      req.setRequestHeader ("Cookie", document.cookie);
    req.setRequestHeader ("Referer", document.location.href);
    req.send(data);
  } else if (window.ActiveXObject) {
    req = new ActiveXObject("Microsoft.XMLHTTP");
    if (req) {
      req.onreadystatechange = load_url_cb;
      req.open("POST", req_url, true);
      req.setRequestHeader ("Content-Type", "application/x-www-form-urlencoded"); 
      if (document.cookie)
	req.setRequestHeader ("Cookie", document.cookie);
      req.setRequestHeader ("Referer", document.location.href);
      req.send(data);
    }
  }
}

// replace a given objet by the content of the given url
function post_form_to_id(form, id) {
  req_target_id = id;
  post_form (form);
}

function post_message(form, id) {
  post_form_to_id (form, id);
}

function load_url_cb() {
  var e;

  if (req == null)
    return;

  if (req.readyState == 4) {
    if (req_target_id) {
      e = document.getElementById (req_target_id);
      
      if (! e ) {
	//	alert ('dst id not defined: ' + req_target_id);
	req = null;
	req_target_id = null;
	return;
      }
      
      if (req.status < 400) {
	if (req_target_id == progress_id) {
	  if (req.responseText.indexOf ('<!-- NOT_MODIFIED -->') >= 0) {
	    req = null;
	    req_target_id = null;
	  } else if (req.responseText.indexOf ('<!-- DONE -->') >= 0) {
	    progress_url = null;
	    progress_id  = null;
	  } else if (req.responseText.indexOf ('<!-- RELOAD -->') >= 0) {
	    progress_url = null;
	    progress_id  = null;
	    window.location.href = window.location.href;
	  }
	}
	
	if (req) {
	  e.innerHTML = req.responseText;
	  show (e);

	  if (req_target_id != null && req_target_id.match (/^(p|dl)_/)) {
	    // posted message status
	    window.scrollTo (0, offsetTop (e));
	  }
	}
	
      } else if (req.status == 304) {
	// not modified
      } else {
	e.innerHTML = '<span class=error> HTTP error: ' + req.statusText + ' - ' + req.status + '</span>';
	
	if (req_target_id == progress_id) {
	  progress_url = null;
	  progress_id  = null;
	}

	show (e);
      }
	
      //      } catch(err) {
      //	progress_url = null;
      //	progress_id  = null;
      //	e.innerHTML = '<span class="error">Connection error ' + 
      //	  '<a href="#" onclick="toggle_visible(\'xerr\'); return false">Show</a>' +
      //	  '<div class="z" id="xerr"><pre>' + err + '</pre></div></span>';      

      //	show (e);
      //      }
    }

    req_target_id = null;
    req = null;
  }
}

function noop() {

}

function show_progress_bar_timeout() {
  if (progress_url != null) {
    if (load_url_to_id (progress_url + '&refresh=' + progress_refresh, progress_id, 1))
			//			req_target_id == progress_id ? null : 1))
      progress_refresh ++;

    window.setTimeout (show_progress_bar_timeout, progress_update_interval);
  }
}

function show_progress_bar(url, id) {
  var e;

  if (id == null) 
    progress_id = 'progress_bar';
  else 
    progress_id = id;
  
  if (url) {
    progress_refresh = 1;
    progress_url = url;
    window.setTimeout (show_progress_bar_timeout, progress_update_interval);
  }
}

function get_child_node_value(node, child_name) {
  var c;
  c = node.getElementsByTagName (child_name);
  if (!c || !c.length)
    return null;
  
  return c[0].firstChild ? c[0].firstChild.nodeValue : null;
}

function download_update_status_cb() {
  var xml;
  var t, c, l, d, e, i, n, div, tag, status, msg, speed;
  
  if (req == null)
    return;
  
  if (req.readyState != 4)
    return;

  xml = req.responseXML;
  req = null;
  if (xml == null)
    return;
  
  t = document.getElementById ('dl');
  c = document.getElementById ('node_template');

  l = xml.getElementsByTagName ('item');

  for (i = 0; i < l.length; i++) {
    d = l[i];

    tag = get_child_node_value (d, 'tag');
    if (tag == 'node_template') 
      continue;

    status = get_child_node_value (d, 'status');
    msg = get_child_node_value (d, 'msg');
    speed = get_child_node_value (d, 'speed');

    if (tag == null || status == null) 
      continue;

    e = document.getElementById (tag);
    
    if (!e) {
      if (status != 'running')
	continue;

      e = c.cloneNode (true);
      e.id = tag;
      c.parentNode.insertBefore (e, c.parentNode.firstChild.nextSibling);      
      e.onmousedown = list_row_onmousedown;
    }  
    
    if (!e) 
      continue;
    
    e.className = e.className.replace (/status_[^ ]*/, 'status_' + status);

    div = e.getElementsByTagName ('div');
    if (!div[1].innerHTML) 
      div[1].innerHTML = get_child_node_value (d, 'title');

    if (!div[0].innerHTML) 
      div[0].innerHTML = get_child_node_value (d, 'size');

    if (status == 'done') {
      div[2].innerHTML = '';
      hide (div[3]);
    } else {
      n = get_child_node_value (d, 'progress');
      if (n) {
	div[3].className = div[3].className.replace (/ z$/, '');
	n = n.replace (/[^0-9]/, '');	
	div[4].style.width = String(n * 2) + 'px';
	n = get_child_node_value (d, 'progress_total')
	if (n) {
	  n = n.replace (/[^0-9]/, '');
	  div[5].style.width = String(n * 2) + 'px';	
	}
      }  else {
	if (!div[3].className.match (/ z$/)) 
	  div[3].className = div[3].className + ' z';
      }
    }

    if (speed && speed != '0') 
      div[2].innerHTML = msg ? msg + ' (' + speed + '/s)' : '(' + speed + '/s)';
    else if (msg) 
      div[2].innerHTML = msg;
  }
}

function download_update_status_timeout() {
  var url = get_base_url() + '?section=download&status=error,running,done&type=xml';
  load_url (url, true, download_update_status_cb);  
  window.setTimeout (download_update_status_timeout, 1000);
}

function download_update_status() {
  window.setTimeout (download_update_status_timeout, 1000);
}
